# std::filesystem::file_size

From cppreference.com
< cpp‎ | filesystem

Defined in header `<filesystem>` |  |
std::uintmax_t file_size( const std::filesystem::path& p ); std::uintmax_t file_size( const std::filesystem::path& p, std::error_code& ec ) noexcept; | (1) | (since C++17)

If `p` does not exist, reports an error.

For a regular file `p`, returns the size determined as if by reading the `st_size` member of the structure obtained by POSIX stat (symlinks are followed)

The result of attempting to determine the size of a directory (as well as any other file that is not a regular file or a symlink) is implementation-defined.

The non-throwing overload returns -1 on errors.

### Parameters

p | - | path to examine
ec | - | out-parameter for error reporting in the non-throwing overload

### Return value

The size of the file, in bytes.

### Exceptions

The overload that does not take a std::error_code& parameter throws `filesystem_error` on underlying OS API errors, constructed with `p` as the first path argument and the OS error code as the error code argument. The overload taking a std::error_code& parameter sets it to the OS API error code if an OS API call fails, and executes ec.clear() if no errors occur. Any overload not marked `noexcept` may throw std::bad_alloc if memory allocation fails.

### Example

Run this code

    #include <iostream>
    #include <fstream>
    #include <filesystem>
    namespace fs = std::filesystem;
    int main()
    {
        fs::path p = fs::current_path() / "example.bin";
        std::ofstream(p).put('a'); // create file of size 1
        std::cout << "File size = " << fs::file_size(p) << '\n';
        fs::remove(p);

        try {
            fs::file_size("/dev"); // attempt to get size of a directory
        } catch(fs::filesystem_error& e) {
            std::cout << e.what() << '\n';
        }
    }

Possible output:

    File size = 1
    filesystem error: cannot get file size: Is a directory [/dev]

### See also

resize_file (C++17) | changes the size of a regular file by truncation or zero-fill (function)
space (C++17) | determines available free space on the file system (function)
file_size | returns the size of the file to which the directory entry refers (public member function of `std::filesystem::directory_entry`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/filesystem/file_size&oldid=108422"